package org.jeecg.modules.app.service;

import org.jeecg.modules.app.vo.CourseInfoVO;
import org.jeecg.modules.app.vo.PlaceInfoVO;

import java.util.List;

public interface IDetailService {
    /**
     * @Author SheepHy
     * @Description 门店详情信息查询
     * @Date 19:41 2025/7/7
     * @Param id 门店id
     * @return PlaceInfoVO {@link PlaceInfoVO}
     **/
    PlaceInfoVO getPlaceInfo(String id);
    
    /** 
     * @Author SheepHy
     * @Description 课程详情
     * @Date 13:36 2025/7/8
     * @Param id 课程id
     * @return CourseInfoVO {@link CourseInfoVO}
     **/
    CourseInfoVO getCourseInfo(String id, double latitude, double longitude);

    /**
     * @Author SheepHy
     * @Description 根据课程类型查询课程列表
     * @Date 9:52 2025/7/9
     * @Param type 课程类型
     * @return List<PlaceInfoVO.CourseInfoVO>
     **/
    List<PlaceInfoVO.CourseInfoVO> courseInfoVOList(String type, String id);
    
    /** 
     * @Author SheepHy
     * @Description 根据类目类型查询体育馆场地空闲时间段(包场 -门店详情页使用)
     * @Date 10:14 2025/7/9
     * @Param id, categoryId
     * @return PlaceInfoVO.theGymnasiumIsCharteredVO
     **/
    PlaceInfoVO.theGymnasiumIsCharteredVO getPlaceInfoNoFixation(String id, String categoryId);
}
