package org.jeecg.modules.system.app.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import org.jeecg.modules.system.app.dto.*;
import org.jeecg.modules.system.app.entity.AppSitePlace;

/**
 * @Description: 商户场所表
 * @Author: jeecg-boot
 * @Date:   2025-07-09
 * @Version: V1.0
 */
public interface IAppSitePlaceService extends IService<AppSitePlace> {
    /**
     *场所新增
     * @param placeDTO
     * @return
     */
    Boolean saveWitchPriceRules(AppSitePlaceDTO placeDTO);
    /**
     * 场所修改
     * @param placeDTO
     * @return
     */
    Boolean editWitchPriceRules(AppSitePlaceDTO placeDTO);
    /**
     * 通过id查询场所
     * @param id
     * @return
     */
    AppSitePlaceDTO queryWitchPriceRulesById(String id);
    /**
     * 删除场所
     * @param id
     * @return
     */
    Boolean deleteWitchPriceRulesById(String id);

    /**
     * 分页列表
     * @param dto
     * @return
     */

    IPage<AppSitePlaceCuDTO> queryWitchPriceRulesPage(AppSitePlacePageDTO dto);




    //Unfixed
    /**
     * 添加无固定场
     * @param unsetDTO
     * @return
     */

    Boolean addUnfixed(AppSitePlaceUnfixedDTO unsetDTO);
    /**
     * 编辑无固定场
     * @param unsetDTO
     * @return
     */
    Boolean updateUnfixed(AppSitePlaceUnfixedDTO unsetDTO);
    /**
     * 删除无固定场
     * @param id
     * @return
     */
    Boolean deleteUnfixed(String id);
    /**
     * 无固定场分页列表
     * @param dto
     * @return
     */
    IPage<AppSitePlaceUnfixedDTO> queryUnfixedPage(AppSitePlaceUnfixedPageDTO dto);
    /**
     * 无固定场详情
     * @param id
     * @return
     */
    AppSitePlaceUnfixedDTO queryUnfixedById(String id);



}
