package org.jeecg.modules.system.app.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.exception.JeecgBootException;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.modules.system.app.dto.*;
import org.jeecg.modules.system.app.entity.AppCategory;
import org.jeecg.modules.system.app.entity.AppSite;
import org.jeecg.modules.system.app.entity.AppSitePlace;
import org.jeecg.modules.system.app.entity.AppSitePriceRules;
import org.jeecg.modules.system.app.enums.SitePlaceTypeEnum;
import org.jeecg.modules.system.app.mapper.AppCategoryMapper;
import org.jeecg.modules.system.app.mapper.AppSiteMapper;
import org.jeecg.modules.system.app.mapper.AppSitePlaceMapper;
import org.jeecg.modules.system.app.mapper.AppSitePriceRulesMapper;
import org.jeecg.modules.system.app.service.IAppSitePlaceService;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;
import java.util.stream.Collectors;

import static org.jeecg.common.constant.CommonConstant.SC_INTERNAL_SERVER_ERROR_500;

/**
 * @Description: 商户场所表
 * @Author: jeecg-boot
 * @Date: 2025-07-09
 * @Version: V1.0
 */
@Service
public class AppSitePlaceServiceImpl extends ServiceImpl<AppSitePlaceMapper, AppSitePlace> implements IAppSitePlaceService {
    @Resource
    private AppSitePriceRulesMapper appSitePriceRulesMapper;
    @Resource
    private AppSiteMapper appSiteMapper;
    @Resource
    private AppCategoryMapper appCategoryMapper;

    //学校 包场 一对多

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean saveWitchPriceRules(AppSitePlaceDTO placeDTO) {
//        AppSitePlaceCuDTO appSitePlaceCuDTO = placeDTO.getAppSitePlaceCuDTO();
//        AppSiteCategoryDOT appSiteCategoryDOT = placeDTO.getAppSiteCategoryDOT();
//        if (null == appSitePlaceCuDTO.getSiteId())
//            throw new JeecgBootException("商户补充信息id不能为空", SC_INTERNAL_SERVER_ERROR_500);
//        AppSite site = appSiteMapper.selectById(appSitePlaceCuDTO.getSiteId());
//        if (site == null) throw new JeecgBootException("商户不存在");
//
//        if (appSitePlaceCuDTO.getInventory() < 1)
//            throw new JeecgBootException("场所数、票数不能为0或负数", SC_INTERNAL_SERVER_ERROR_500);
//        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
//        for (String s : appSitePlaceCuDTO.getCategoryId().split(",")) {
//            AppCategory category = appCategoryMapper.selectById(s);
//            for (int i = 0; i < appSitePlaceCuDTO.getInventory(); i++) {
//                AppSitePlace appSitePlace = new AppSitePlace();
//                BeanUtils.copyProperties(appSitePlaceCuDTO, appSitePlace);
//                appSitePlace.setName(category.getName() + i);
//                appSitePlace.setOrgCode(site.getOrgCode());
//                appSitePlace.setTenantId(site.getTenantId());
//                appSitePlace.setSiteId(site.getId());
//                int insert = baseMapper.insert(appSitePlace);
//                if (insert < 1) {
//                    throw new JeecgBootException("商户场所保存失败");
//                }
//                placeDTO.getSiteRuleDTOS().forEach(rule -> {
//                    AppSitePriceRules appSitePriceRules = new AppSitePriceRules();
//                    BeanUtils.copyProperties(rule, appSitePriceRules);
//                    appSitePriceRules.setSitePlaceId(appSitePlace.getId());
//                    appSitePriceRules.setOrgCode(appSitePlace.getOrgCode());
//                    appSitePriceRules.setTenantId(appSitePlace.getTenantId());
//                    int savePriceResult = appSitePriceRulesMapper.insert(appSitePriceRules);
//                    if (savePriceResult < 1) {
//                        throw new JeecgBootException("场所价格规则保存失败", SC_INTERNAL_SERVER_ERROR_500);
//                    }
//                });
//            }
//        }

        //循环添加



        return Boolean.TRUE;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean editWitchPriceRules(AppSitePlaceDTO placeDTO) {
//        AppSitePlaceCuDTO appSitePlaceCuDTO = placeDTO.getAppSitePlaceCuDTO();
//        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
//        if (null == appSitePlaceCuDTO.getSiteId())
//            throw new JeecgBootException("商户补充信息id不能为空", SC_INTERNAL_SERVER_ERROR_500);
//        AppSite site = appSiteMapper.selectById(appSitePlaceCuDTO.getSiteId());
//        if (site == null) throw new JeecgBootException("商户不存在");
//        List<AppSitePlace> dbPlaceList = baseMapper.selectList(Wrappers.<AppSitePlace>lambdaQuery().eq(AppSitePlace::getSiteId, appSitePlaceCuDTO.getSiteId()));
//        if (dbPlaceList.isEmpty()) throw new JeecgBootException("数据不存在", SC_INTERNAL_SERVER_ERROR_500);
//        //部门校验
////        checkPermission(dbPlace, sysUser);
//        Integer inventoryNew = appSitePlaceCuDTO.getInventory();
//        if (inventoryNew < 1) throw new JeecgBootException("场所数、票数不能为0或负数", SC_INTERNAL_SERVER_ERROR_500);
//        int size = dbPlaceList.size();
//        List<AppSiteRuleDTO> siteRuleDTOS = placeDTO.getSiteRuleDTOS();
//        //场所数量判断
//        if (size == inventoryNew) {
//            dbPlaceList.forEach(dbPlace -> {
//                AppSitePlace appSitePlace = new AppSitePlace();
//                BeanUtils.copyProperties(appSitePlaceCuDTO, appSitePlace);
//                //不许更改项赋值
//                appSitePlace.setOrgCode(site.getOrgCode());
//                appSitePlace.setTenantId(site.getTenantId());
//                int update = baseMapper.updateById(appSitePlace);
//                if (update < 1) {
//                    throw new JeecgBootException("商户场所保存失败");
//                }
//
//                appSitePriceRulesMapper.selectList(Wrappers.<AppSitePriceRules>lambdaQuery()
//                        .eq(AppSitePriceRules::getSitePlaceId, dbPlace.getId())).forEach(appSitePriceRules -> {
//
//                });
//
//            });
//
//
//        }
//
//        AppSitePlace appSitePlace = new AppSitePlace();
//        BeanUtils.copyProperties(appSitePlaceCuDTO, appSitePlace);
//        //不许更改项赋值
//        appSitePlace.setOrgCode(site.getOrgCode());
//        appSitePlace.setTenantId(site.getTenantId());
//        int update = baseMapper.updateById(appSitePlace);
//        if (update < 1) {
//            throw new JeecgBootException("商户场所保存失败");
//        }
//        List<AppSitePriceRules> dbRulesList = appSitePriceRulesMapper.selectList(Wrappers.<AppSitePriceRules>lambdaQuery()
//                .eq(AppSitePriceRules::getSitePlaceId, appSitePlace.getId()));
//        List<AppSiteRuleDTO> siteRuleDTOS = placeDTO.getSiteRuleDTOS();
//        //删除
//        List<AppSitePriceRules> deleteList = dbRulesList.stream().filter(
//                dbRule -> dbRule.getId() != null && siteRuleDTOS.stream().noneMatch(rule -> dbRule.getId().equals(rule.getId()))).collect(Collectors.toList());
//        deleteList.forEach(
//                dbRule -> {
//                    int deleteResult = appSitePriceRulesMapper.deleteById(dbRule.getId());
//                    if (deleteResult < 1) {
//                        throw new JeecgBootException("场所价格规则删除失败");
//                    }
//                }
//        );
//        //保存
//        List<AppSitePriceRules> addList = siteRuleDTOS.stream().filter(rule -> rule.getId() == null).map(ruleDTO -> {
//            AppSitePriceRules appSitePriceRules = new AppSitePriceRules();
//            BeanUtils.copyProperties(ruleDTO, appSitePriceRules);
//            appSitePriceRules.setOrgCode(appSitePlace.getOrgCode());
//            appSitePriceRules.setTenantId(appSitePlace.getTenantId());
//            appSitePriceRules.setSitePlaceId(appSitePlace.getId());
//            return appSitePriceRules;
//        }).collect(Collectors.toList());
//        addList.forEach(appSitePriceRules -> {
//            int saveResult = appSitePriceRulesMapper.insert(appSitePriceRules);
//            if (saveResult < 1) {
//                throw new JeecgBootException("场所价格规则保存失败", SC_INTERNAL_SERVER_ERROR_500);
//            }
//        });
//        //更新
//        List<AppSitePriceRules> updateList = siteRuleDTOS.stream().filter(
//                rule -> rule.getId() != null && dbRulesList.stream().anyMatch(
//                        dbRule -> dbRule.getId().equals(rule.getId()))).map(ruleDto -> {
//            AppSitePriceRules appSitePriceRules = new AppSitePriceRules();
//            BeanUtils.copyProperties(ruleDto, appSitePriceRules);
//            appSitePriceRules.setSitePlaceId(appSitePlace.getId());
//            appSitePriceRules.setOrgCode(appSitePlace.getOrgCode());
//            appSitePriceRules.setTenantId(appSitePlace.getTenantId());
//            return appSitePriceRules;
//        }).collect(Collectors.toList());
//        updateList.forEach(rule -> {
//            int updateById = appSitePriceRulesMapper.updateById(rule);
//            if (updateById < 1) {
//                throw new JeecgBootException("场所价格规则更新失败", SC_INTERNAL_SERVER_ERROR_500);
//            }
//        });
        return Boolean.TRUE;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public AppSitePlaceDTO queryWitchPriceRulesById(String id) {
        AppSitePlace appSitePlace = baseMapper.selectById(id);
        if (null == appSitePlace) throw new JeecgBootException("数据不存在", SC_INTERNAL_SERVER_ERROR_500);
        AppSitePlaceCuDTO appSitePlaceCuDTO = new AppSitePlaceCuDTO();
        BeanUtils.copyProperties(appSitePlace, appSitePlaceCuDTO);
        List<AppSiteRuleDTO> collect = appSitePriceRulesMapper.selectList(Wrappers.<AppSitePriceRules>lambdaQuery()
                .eq(AppSitePriceRules::getSitePlaceId, appSitePlace.getId())).stream().map(
                appSitePriceRules -> {
                    AppSiteRuleDTO appSiteRuleDTO = new AppSiteRuleDTO();
                    BeanUtils.copyProperties(appSitePriceRules, appSiteRuleDTO);
                    return appSiteRuleDTO;
                }).collect(Collectors.toList());

        return new AppSitePlaceDTO(appSitePlaceCuDTO, collect,null);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean deleteWitchPriceRulesById(String id) {
        AppSitePlace dbPlace = baseMapper.selectById(id);
        if (null == dbPlace) throw new JeecgBootException("未找到对应数据", SC_INTERNAL_SERVER_ERROR_500);
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
//        checkPermission(dbPlace,sysUser);
        int deleteById = baseMapper.deleteById(id);
        if (deleteById < 1) throw new JeecgBootException("删除失败", SC_INTERNAL_SERVER_ERROR_500);
        int deletePriceResult = appSitePriceRulesMapper.delete(Wrappers.<AppSitePriceRules>lambdaQuery().eq(AppSitePriceRules::getSitePlaceId, id));
        if (deletePriceResult < 1) throw new JeecgBootException("场地价格规则删除失败", SC_INTERNAL_SERVER_ERROR_500);
        return Boolean.TRUE;
    }

    @Override
    public IPage<AppSitePlaceCuDTO> queryWitchPriceRulesPage(AppSitePlacePageDTO dto) {
        if (null == dto.getType()) throw new JeecgBootException("请选择类型", SC_INTERNAL_SERVER_ERROR_500);
        LoginUser loginUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        Page<AppSitePlace> page = new Page<>(dto.getPageNum(), dto.getPageSize());
        LambdaQueryWrapper<AppSitePlace> wrapper = Wrappers.<AppSitePlace>lambdaQuery().eq(AppSitePlace::getType, dto.getType())
                .like(StringUtils.isNotBlank(dto.getName()), AppSitePlace::getName, dto.getName());
//                .eq(AppSitePlace::getOrgCode, loginUser.getOrgCode());
        IPage<AppSitePlace> resultPage = baseMapper.selectPage(page, wrapper);
        return resultPage.convert(record -> {
            AppSitePlaceCuDTO cuDTO = new AppSitePlaceCuDTO();
            BeanUtils.copyProperties(record, cuDTO);
            return cuDTO;
        });
    }

    // 无固定场
    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean addUnfixed(AppSitePlaceUnfixedDTO unsetDTO) {
        if (null == unsetDTO.getSiteId()) throw new JeecgBootException("请选择商户门店", SC_INTERNAL_SERVER_ERROR_500);
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        AppSitePlace appSitePlace = new AppSitePlace();
        BeanUtils.copyProperties(unsetDTO, appSitePlace);
        appSitePlace.setType(SitePlaceTypeEnum.UNFIXED.getCode());
        appSitePlace.setOrgCode(sysUser.getOrgCode());
        appSitePlace.setTenantId(sysUser.getOrgId());
        int insert = baseMapper.insert(appSitePlace);
        if (insert < 1) throw new JeecgBootException("无固定场添加失败", SC_INTERNAL_SERVER_ERROR_500);
        AppSitePriceRules appSitePriceRules = new AppSitePriceRules();
        appSitePriceRules.setSitePlaceId(appSitePlace.getId());
        appSitePriceRules.setOrgCode(appSitePlace.getOrgCode());
        appSitePriceRules.setTenantId(appSitePlace.getTenantId());
        int insert1 = appSitePriceRulesMapper.insert(appSitePriceRules);
        if (insert1 < 1) throw new JeecgBootException("无固定场价格添加失败", SC_INTERNAL_SERVER_ERROR_500);
        return Boolean.TRUE;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean updateUnfixed(AppSitePlaceUnfixedDTO unsetDTO) {
        if (null == unsetDTO.getSiteId())
            throw new JeecgBootException("商户门店不能为空", SC_INTERNAL_SERVER_ERROR_500);
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();

        AppSitePlace dbSitePlace = baseMapper.selectById(unsetDTO.getId());
        if (null == dbSitePlace) throw new JeecgBootException("数据不存在", SC_INTERNAL_SERVER_ERROR_500);
//        checkPermission(dbSitePlace,sysUser);

        AppSitePlace appSitePlace = new AppSitePlace();
        BeanUtils.copyProperties(unsetDTO, appSitePlace);
        //固定
        appSitePlace.setType(SitePlaceTypeEnum.UNFIXED.getCode());
        appSitePlace.setOrgCode(sysUser.getOrgCode());
        appSitePlace.setTenantId(sysUser.getOrgId());
        int updateById = baseMapper.updateById(appSitePlace);
        if (updateById < 1) throw new JeecgBootException("无固定场编辑失败", SC_INTERNAL_SERVER_ERROR_500);
        AppSitePriceRules appSitePriceRules = new AppSitePriceRules();
        appSitePriceRules.setSitePlaceId(appSitePlace.getId());
        appSitePriceRules.setOrgCode(appSitePlace.getOrgCode());
        appSitePriceRules.setTenantId(appSitePlace.getTenantId());
        int updateById1 = appSitePriceRulesMapper.updateById(appSitePriceRules);
        if (updateById1 < 1) throw new JeecgBootException("无固定场价格编辑失败", SC_INTERNAL_SERVER_ERROR_500);
        return Boolean.TRUE;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean deleteUnfixed(String id) {
        AppSitePlace dbPlace = baseMapper.selectById(id);
        if (null == dbPlace) throw new JeecgBootException("未找到对应数据", SC_INTERNAL_SERVER_ERROR_500);
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
//        dbPlace.setUpdateBy(sysUser.getUsername());
        int deleteById = baseMapper.deleteById(dbPlace);
        if (deleteById < 1) throw new JeecgBootException("无固定场删除失败", SC_INTERNAL_SERVER_ERROR_500);
        int deleteById1 = appSitePriceRulesMapper.delete(Wrappers.<AppSitePriceRules>lambdaQuery().eq(AppSitePriceRules::getSitePlaceId, id));
        if (deleteById1 < 1) throw new JeecgBootException("固定场价格规则删除失败", SC_INTERNAL_SERVER_ERROR_500);
        return null;
    }

    @Override
    public IPage<AppSitePlaceUnfixedDTO> queryUnfixedPage(AppSitePlaceUnfixedPageDTO dto) {
        Page<AppSitePlace> page = new Page<>(dto.getPageNum(), dto.getPageSize());
        LambdaQueryWrapper<AppSitePlace> wrapper = Wrappers.<AppSitePlace>lambdaQuery().eq(AppSitePlace::getType, SitePlaceTypeEnum.UNFIXED.getCode())
                .eq(AppSitePlace::getSiteId, dto.getSiteId())
                .like(StringUtils.isNotBlank(dto.getName()), AppSitePlace::getName, dto.getName());

        IPage<AppSitePlace> resultPage = baseMapper.selectPage(page, wrapper);
        return resultPage.convert(record -> {
            AppSitePlaceUnfixedDTO appSitePlaceUnfixedDTO = new AppSitePlaceUnfixedDTO();
            BeanUtils.copyProperties(record, appSitePlaceUnfixedDTO);
            AppSitePriceRules appSitePriceRules = appSitePriceRulesMapper.selectOne(
                    Wrappers.<AppSitePriceRules>lambdaQuery().eq(AppSitePriceRules::getSitePlaceId, record.getId()));
            appSitePlaceUnfixedDTO.setOriginalPrice(appSitePriceRules.getOriginalPrice());
            appSitePlaceUnfixedDTO.setSellingPrice(appSitePriceRules.getSellingPrice());
            return appSitePlaceUnfixedDTO;
        });
    }

    @Override
    public AppSitePlaceUnfixedDTO queryUnfixedById(String id) {
        AppSitePlace dbSitePlace = baseMapper.selectById(id);
        if (null == dbSitePlace) throw new JeecgBootException("无固定场数据不存在", SC_INTERNAL_SERVER_ERROR_500);
        AppSitePriceRules appSitePriceRules = appSitePriceRulesMapper.selectOne(
                Wrappers.<AppSitePriceRules>lambdaQuery().eq(AppSitePriceRules::getSitePlaceId, dbSitePlace.getId()));
        AppSitePlaceUnfixedDTO appSitePlaceUnfixedDTO = new AppSitePlaceUnfixedDTO();
        BeanUtils.copyProperties(dbSitePlace, appSitePlaceUnfixedDTO);
        appSitePlaceUnfixedDTO.setOriginalPrice(appSitePriceRules.getOriginalPrice());
        appSitePlaceUnfixedDTO.setSellingPrice(appSitePriceRules.getSellingPrice());

        return appSitePlaceUnfixedDTO;
    }

    /**
     * 权限校验
     *
     * @param place
     * @param sysUser
     */
    private void checkPermission(AppSitePlace place, LoginUser sysUser) {
        if (!sysUser.getOrgCode().equals(place.getOrgCode()))
            throw new JeecgBootException("无权限操作", SC_INTERNAL_SERVER_ERROR_500);
    }
}
